Index: kernel/generic/include/ddi/irq.h
===================================================================
--- kernel/generic/include/ddi/irq.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/ddi/irq.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -43,4 +43,5 @@
 #include <proc/task.h>
 #include <ipc/ipc.h>
+#include <mm/slab.h>
 
 typedef enum {
@@ -70,4 +71,6 @@
 	/** When false, notifications are not sent. */
 	bool notify;
+	/** True if the structure is in irq_uspace_hash_table_table */
+	bool hashed_in;
 	/** Answerbox for notifications. */
 	answerbox_t *answerbox;
@@ -76,14 +79,8 @@
 	/** Arguments that will be sent if the IRQ is claimed. */
 	uint32_t scratch[IPC_CALL_LEN];
-	/** Top-half pseudocode. */
+	/** Top-half IRQ code. */
 	irq_code_t *code;
 	/** Counter. */
 	size_t counter;
-	
-	/**
-	 * Link between IRQs that are notifying the same answerbox. The list is
-	 * protected by the answerbox irq_lock.
-	 */
-	link_t link;
 } ipc_notif_cfg_t;
 
@@ -91,10 +88,9 @@
  *
  * If one device has multiple interrupts, there will be multiple irq_t
- * instantions with the same devno.
- *
+ * instantions.
  */
 typedef struct irq {
 	/** Hash table link. */
-	link_t link;
+	ht_link_t link;
 	
 	/** Lock protecting everything in this structure
@@ -112,7 +108,4 @@
 	 */
 	bool preack;
-	
-	/** Unique device number. -1 if not yet assigned. */
-	devno_t devno;
 	
 	/** Actual IRQ number. -1 if not yet assigned. */
@@ -139,4 +132,6 @@
 extern hash_table_t irq_uspace_hash_table;
 
+extern slab_cache_t *irq_slab;
+
 extern inr_t last_inr;
 
Index: kernel/generic/include/debug.h
===================================================================
--- kernel/generic/include/debug.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/debug.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,64 +36,8 @@
 #define KERN_DEBUG_H_
 
-#include <panic.h>
 #include <log.h>
 #include <symtab_lookup.h>
 
 #define CALLER  ((uintptr_t) __builtin_return_address(0))
-
-#ifdef CONFIG_DEBUG
-
-/** Debugging ASSERT macro
- *
- * If CONFIG_DEBUG is set, the ASSERT() macro
- * evaluates expr and if it is false raises
- * kernel panic.
- *
- * @param expr Expression which is expected to be true.
- *
- */
-#define ASSERT(expr) \
-	do { \
-		if (!(expr)) \
-			panic_assert("%s() at %s:%u:\n%s", \
-			    __func__, __FILE__, __LINE__, #expr); \
-	} while (0)
-
-/** Debugging verbose ASSERT macro
- *
- * If CONFIG_DEBUG is set, the ASSERT() macro
- * evaluates expr and if it is false raises
- * kernel panic. The panic message contains also
- * the supplied message.
- *
- * @param expr Expression which is expected to be true.
- * @param msg  Additional message to show (string).
- *
- */
-#define ASSERT_VERBOSE(expr, msg) \
-	do { \
-		if (!(expr)) \
-			panic_assert("%s() at %s:%u:\n%s, %s", \
-			    __func__, __FILE__, __LINE__, #expr, msg); \
-	} while (0)
-
-/** Static assert macro
- *
- */
-#define STATIC_ASSERT(expr) \
-	_Static_assert(expr, "")
-
-#define STATIC_ASSERT_VERBOSE(expr, msg) \
-	_Static_assert(expr, msg)
-
-
-#else /* CONFIG_DEBUG */
-
-#define ASSERT(expr)
-#define ASSERT_VERBOSE(expr, msg)
-#define STATIC_ASSERT(expr)
-#define STATIC_ASSERT_VERBOSE(expr, msg)
-
-#endif /* CONFIG_DEBUG */
 
 #ifdef CONFIG_LOG
Index: kernel/generic/include/func.h
===================================================================
--- kernel/generic/include/func.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/func.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,4 @@
 #define KERN_FUNC_H_
 
-#include <typedefs.h>
 #include <atomic.h>
 
Index: kernel/generic/include/gsort.h
===================================================================
--- kernel/generic/include/gsort.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ kernel/generic/include/gsort.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2005 Sergey Bondari
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_GSORT_H_
+#define KERN_GSORT_H_
+
+#include <stdbool.h>
+#include <stddef.h>
+
+typedef int (* sort_cmp_t)(void *, void *, void *);
+
+extern bool gsort(void *, size_t, size_t, sort_cmp_t, void *);
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/ipc/ipc.h
===================================================================
--- kernel/generic/include/ipc/ipc.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/ipc/ipc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -42,6 +42,6 @@
 #include <abi/proc/task.h>
 #include <typedefs.h>
-
-#define IPC_MAX_PHONES  64
+#include <mm/slab.h>
+#include <cap/cap.h>
 
 struct answerbox;
@@ -62,5 +62,5 @@
 
 /** Structure identifying phone (in TASK structure) */
-typedef struct {
+typedef struct phone {
 	mutex_t lock;
 	link_t link;
@@ -69,4 +69,5 @@
 	ipc_phone_state_t state;
 	atomic_t active_calls;
+	kobject_t *kobject;
 } phone_t;
 
@@ -94,6 +95,4 @@
 	/** Notifications from IRQ handlers. */
 	list_t irq_notifs;
-	/** IRQs with notifications to this answerbox. */
-	list_t irq_list;
 } answerbox_t;
 
@@ -170,4 +169,6 @@
 } call_t;
 
+extern slab_cache_t *phone_slab;
+
 extern answerbox_t *ipc_phone_0;
 
Index: kernel/generic/include/ipc/ipcrsc.h
===================================================================
--- kernel/generic/include/ipc/ipcrsc.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/ipc/ipcrsc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,10 +38,10 @@
 #include <proc/task.h>
 #include <ipc/ipc.h>
+#include <cap/cap.h>
 
 extern call_t *get_call(sysarg_t);
-extern int phone_get(sysarg_t, phone_t **);
-extern int phone_alloc(task_t *);
-extern bool phone_connect(int, answerbox_t *);
-extern void phone_dealloc(int);
+extern cap_handle_t phone_alloc(task_t *);
+extern bool phone_connect(cap_handle_t, answerbox_t *);
+extern void phone_dealloc(cap_handle_t);
 
 #endif
Index: kernel/generic/include/ipc/irq.h
===================================================================
--- kernel/generic/include/ipc/irq.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/ipc/irq.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -47,12 +47,10 @@
 #include <adt/list.h>
 
-extern int ipc_irq_subscribe(answerbox_t *, inr_t, devno_t, sysarg_t,
-    irq_code_t *);
 
 extern irq_ownership_t ipc_irq_top_half_claim(irq_t *);
 extern void ipc_irq_top_half_handler(irq_t *);
 
-extern int ipc_irq_unsubscribe(answerbox_t *, inr_t, devno_t);
-extern void ipc_irq_cleanup(answerbox_t *);
+extern int ipc_irq_subscribe(answerbox_t *, inr_t, sysarg_t, irq_code_t *);
+extern int ipc_irq_unsubscribe(answerbox_t *, int);
 
 /*
Index: kernel/generic/include/ipc/sysipc.h
===================================================================
--- kernel/generic/include/ipc/sysipc.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/ipc/sysipc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -56,6 +56,6 @@
 extern sysarg_t sys_ipc_hangup(sysarg_t);
 
-extern sysarg_t sys_ipc_irq_subscribe(inr_t, devno_t, sysarg_t, irq_code_t *);
-extern sysarg_t sys_ipc_irq_unsubscribe(inr_t, devno_t);
+extern sysarg_t sys_ipc_irq_subscribe(inr_t, sysarg_t, irq_code_t *);
+extern sysarg_t sys_ipc_irq_unsubscribe(sysarg_t);
 
 #ifdef __32_BITS__
Index: kernel/generic/include/lib/elf.h
===================================================================
--- kernel/generic/include/lib/elf.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/lib/elf.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,4 @@
 #define KERN_ELF_H_
 
-#include <typedefs.h>
 #include <abi/elf.h>
 #include <arch/elf.h>
Index: kernel/generic/include/lib/elf_load.h
===================================================================
--- kernel/generic/include/lib/elf_load.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/lib/elf_load.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,4 @@
 
 #include <arch/elf.h>
-#include <typedefs.h>
 
 /**
Index: kernel/generic/include/lib/memfnc.h
===================================================================
--- kernel/generic/include/lib/memfnc.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/lib/memfnc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_LIB_MEMFNC_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 #include <cc.h>
 
Index: kernel/generic/include/lib/ra.h
===================================================================
--- kernel/generic/include/lib/ra.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/lib/ra.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -71,5 +71,13 @@
 typedef struct {
 	link_t segment_link;	/**< Span's segment list link. */
-	link_t fu_link;		/**< Span's free list or used hash link. */
+
+	/*
+	 * A segment cannot be both on the free list and in the used hash.
+	 * Their respective links can therefore occupy the same space.
+	 */
+	union {
+		link_t fl_link;		/**< Span's free list link. */
+		ht_link_t uh_link;	/**< Span's used hash link. */
+	};
 
 	uintptr_t base;		/**< Segment base. */
@@ -79,6 +87,7 @@
 extern void ra_init(void);
 extern ra_arena_t *ra_arena_create(void);
+extern void ra_arena_destroy(ra_arena_t *);
 extern bool ra_span_add(ra_arena_t *, uintptr_t, size_t);
-extern uintptr_t ra_alloc(ra_arena_t *, size_t, size_t);
+extern bool ra_alloc(ra_arena_t *, size_t, size_t, uintptr_t *);
 extern void ra_free(ra_arena_t *, uintptr_t, size_t);
 
Index: kernel/generic/include/lib/rd.h
===================================================================
--- kernel/generic/include/lib/rd.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/lib/rd.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_RD_H_
 
-#include <typedefs.h>
+#include <stddef.h>
 
 extern void init_rd(void *, size_t);
Index: kernel/generic/include/log.h
===================================================================
--- kernel/generic/include/log.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/log.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,6 +36,6 @@
 #define KERN_LOG_H_
 
-#include <typedefs.h>
 #include <stdarg.h>
+#include <stddef.h>
 #include <printf/verify.h>
 #include <abi/log.h>
Index: kernel/generic/include/macros.h
===================================================================
--- kernel/generic/include/macros.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/macros.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,5 @@
 #ifndef __ASM__
 
-#include <typedefs.h>
+#include <stdint.h>
 #include <trace.h>
 
Index: kernel/generic/include/mem.h
===================================================================
--- kernel/generic/include/mem.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ kernel/generic/include/mem.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,61 @@
+/*
+ * Copyright (c) 2001-2004 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_MEM_H_
+#define KERN_MEM_H_
+
+#include <stddef.h>
+#include <stdint.h>
+#include <cc.h>
+
+#ifdef CONFIG_LTO
+#define DO_NOT_DISCARD ATTRIBUTE_USED
+#else
+#define DO_NOT_DISCARD
+#endif
+
+#define memset(dst, val, cnt)  __builtin_memset((dst), (val), (cnt))
+#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
+
+extern void memsetb(void *, size_t, uint8_t)
+    __attribute__((nonnull(1)));
+extern void memsetw(void *, size_t, uint16_t)
+    __attribute__((nonnull(1)));
+extern void *memmove(void *, const void *, size_t)
+    __attribute__((nonnull(1, 2))) DO_NOT_DISCARD;
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/mm/reserve.h
===================================================================
--- kernel/generic/include/mm/reserve.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/mm/reserve.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,6 @@
 #define KERN_RESERVE_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stddef.h>
 
 extern void reserve_init(void);
Index: kernel/generic/include/panic.h
===================================================================
--- kernel/generic/include/panic.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/panic.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #define KERN_PANIC_H_
 
+#include <stdbool.h>
+#include <stddef.h>
 #include <typedefs.h>
 #include <print.h>
Index: kernel/generic/include/preemption.h
===================================================================
--- kernel/generic/include/preemption.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/preemption.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,6 +37,6 @@
 
 #include <arch.h>
+#include <assert.h>
 #include <compiler/barrier.h>
-#include <debug.h>
 
 #define PREEMPTION_INC         (1 << 0)
@@ -54,5 +54,5 @@
 #define preemption_enable() \
 	do { \
-		ASSERT(PREEMPTION_DISABLED); \
+		assert(PREEMPTION_DISABLED); \
 		compiler_barrier(); \
 		THE->preemption -= PREEMPTION_INC; \
Index: kernel/generic/include/print.h
===================================================================
--- kernel/generic/include/print.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/print.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,6 +36,6 @@
 #define KERN_PRINT_H_
 
-#include <typedefs.h>
 #include <stdarg.h>
+#include <stddef.h>
 #include <printf/verify.h>
 
Index: kernel/generic/include/printf/printf_core.h
===================================================================
--- kernel/generic/include/printf/printf_core.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/printf/printf_core.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,6 +36,6 @@
 #define KERN_PRINTF_CORE_H_
 
-#include <typedefs.h>
 #include <stdarg.h>
+#include <stddef.h>
 
 /** Structure for specifying output methods for different printf clones. */
Index: kernel/generic/include/proc/scheduler.h
===================================================================
--- kernel/generic/include/proc/scheduler.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/proc/scheduler.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,7 +36,7 @@
 #define KERN_SCHEDULER_H_
 
+#include <stddef.h>
 #include <synch/spinlock.h>
 #include <time/clock.h>
-#include <typedefs.h>
 #include <atomic.h>
 #include <adt/list.h>
Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/proc/task.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -48,5 +48,5 @@
 #include <adt/cht.h>
 #include <adt/list.h>
-#include <security/cap.h>
+#include <security/perm.h>
 #include <arch/proc/task.h>
 #include <arch/proc/thread.h>
@@ -60,4 +60,5 @@
 #include <abi/sysinfo.h>
 #include <arch.h>
+#include <cap/cap.h>
 
 #define TASK                 THE->task
@@ -65,4 +66,5 @@
 
 struct thread;
+struct cap;
 
 /** Task structure. */
@@ -93,6 +95,9 @@
 	atomic_t lifecount;
 	
-	/** Task capabilities. */
-	cap_t capabilities;
+	/** Task permissions. */
+	perm_t perms;
+
+	/** Capabilities */
+	cap_info_t *cap_info;
 	
 	/* IPC stuff */
@@ -100,7 +105,4 @@
 	/** Receiving communication endpoint */
 	answerbox_t answerbox;
-
-	/** Sending communication endpoints */
-	phone_t phones[IPC_MAX_PHONES];
 
 	/** Spinlock protecting the active_calls list. */
@@ -159,6 +161,6 @@
 extern void task_print_list(bool);
 
-extern void cap_set(task_t *, cap_t);
-extern cap_t cap_get(task_t *);
+extern void perm_set(task_t *, perm_t);
+extern perm_t perm_get(task_t *);
 
 #ifndef task_create_arch
Index: kernel/generic/include/security/perm.h
===================================================================
--- kernel/generic/include/security/perm.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ kernel/generic/include/security/perm.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,92 @@
+/*
+ * Copyright (c) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+/**
+ * @file
+ * @brief Task permissions definitions.
+ *
+ * Permissions represent virtual rights that entitle their
+ * holder to perform certain security sensitive tasks.
+ *
+ * Each task can have arbitrary combination of the permissions 
+ * defined in this file. Therefore, they are required to be powers
+ * of two.
+ */
+
+#ifndef __PERM_H__
+#define __PERM_H__
+
+#include <typedefs.h>
+
+/**
+ * PERM_PERM allows its holder to grant/revoke arbitrary permission to/from
+ * other tasks.
+ */
+#define PERM_PERM        (1 << 0)
+
+/**
+ * PERM_MEM_MANAGER allows its holder to map physical memory to other tasks.
+ */
+#define PERM_MEM_MANAGER (1 << 1)
+
+/**
+ * PERM_IO_MANAGER allows its holder to access I/O space to other tasks.
+ */
+#define PERM_IO_MANAGER  (1 << 2)
+
+/**
+ * PERM_IRQ_REG entitles its holder to register IRQ handlers.
+ */
+#define PERM_IRQ_REG     (1 << 3)
+
+typedef uint32_t perm_t;
+
+#ifdef __32_BITS__
+
+extern sysarg_t sys_perm_grant(sysarg64_t *, perm_t);
+extern sysarg_t sys_perm_revoke(sysarg64_t *, perm_t);
+
+#endif  /* __32_BITS__ */
+
+#ifdef __64_BITS__
+
+extern sysarg_t sys_perm_grant(sysarg_t, perm_t);
+extern sysarg_t sys_perm_revoke(sysarg_t, perm_t);
+
+#endif  /* __64_BITS__ */
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/stacktrace.h
===================================================================
--- kernel/generic/include/stacktrace.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/stacktrace.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #define KERN_STACKTRACE_H_
 
+#include <stdbool.h>
 #include <typedefs.h>
 
Index: kernel/generic/include/stdbool.h
===================================================================
--- kernel/generic/include/stdbool.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ kernel/generic/include/stdbool.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2006 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_BOOL_H_
+#define KERN_BOOL_H_
+
+#include <abi/bool.h>
+
+#define false  0
+#define true   1
+
+#define __bool_true_false_are_defined 1
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/stddef.h
===================================================================
--- kernel/generic/include/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ kernel/generic/include/stddef.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,51 @@
+/*
+ * Copyright (c) 2006 Josef Cejka
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_STDDEF_H_
+#define KERN_STDDEF_H_
+
+#include <arch/types.h>
+
+typedef native_t ptrdiff_t;
+
+#ifndef NULL
+	#define NULL  ((void *) 0)
+#endif
+
+#define offsetof(type,member) ((size_t) &(((type *) 0)->member))
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/stdint.h
===================================================================
--- kernel/generic/include/stdint.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/stdint.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #define KERN_STDINT_H_
 
+#include <arch/common.h>
+
 #define INT8_MIN  INT8_C(0x80)
 #define INT8_MAX  INT8_C(0x7F)
Index: kernel/generic/include/str.h
===================================================================
--- kernel/generic/include/str.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/str.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,7 @@
 #define KERN_STR_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stddef.h>
+#include <stdint.h>
 
 /**< Common Unicode characters */
Index: kernel/generic/include/synch/condvar.h
===================================================================
--- kernel/generic/include/synch/condvar.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/synch/condvar.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_CONDVAR_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 #include <synch/waitq.h>
 #include <synch/mutex.h>
Index: kernel/generic/include/synch/futex.h
===================================================================
--- kernel/generic/include/synch/futex.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/synch/futex.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
 #include <typedefs.h>
 #include <synch/waitq.h>
+#include <adt/hash_table.h>
 
 /** Kernel-side futex structure. */
@@ -46,5 +47,5 @@
 	waitq_t wq;
 	/** Futex hash table link. */
-	link_t ht_link;
+	ht_link_t ht_link;
 	/** Number of tasks that reference this futex. */
 	size_t refcount;
Index: kernel/generic/include/synch/mutex.h
===================================================================
--- kernel/generic/include/synch/mutex.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/synch/mutex.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,6 @@
 #define KERN_MUTEX_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
+#include <stdint.h>
 #include <synch/semaphore.h>
 #include <abi/synch.h>
Index: kernel/generic/include/synch/rcu.h
===================================================================
--- kernel/generic/include/synch/rcu.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/synch/rcu.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #define KERN_RCU_H_
 
+#include <assert.h>
 #include <synch/rcu_types.h>
 #include <compiler/barrier.h>
@@ -162,5 +163,5 @@
 static inline void _rcu_record_qs(void)
 {
-	ASSERT(PREEMPTION_DISABLED || interrupts_disabled());
+	assert(PREEMPTION_DISABLED || interrupts_disabled());
 	
 	/* 
@@ -207,5 +208,5 @@
 static inline void rcu_read_lock(void)
 {
-	ASSERT(CPU);
+	assert(CPU);
 	preemption_disable();
 
@@ -222,5 +223,5 @@
 static inline void rcu_read_unlock(void)
 {
-	ASSERT(CPU);
+	assert(CPU);
 	preemption_disable();
 	
Index: kernel/generic/include/synch/semaphore.h
===================================================================
--- kernel/generic/include/synch/semaphore.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/synch/semaphore.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define KERN_SEMAPHORE_H_
 
-#include <typedefs.h>
+#include <stdint.h>
 #include <synch/waitq.h>
 #include <abi/synch.h>
Index: kernel/generic/include/synch/spinlock.h
===================================================================
--- kernel/generic/include/synch/spinlock.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ kernel/generic/include/synch/spinlock.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,9 +36,9 @@
 #define KERN_SPINLOCK_H_
 
-#include <typedefs.h>
+#include <stdbool.h>
 #include <arch/barrier.h>
+#include <assert.h>
 #include <preemption.h>
 #include <atomic.h>
-#include <debug.h>
 #include <arch/asm.h>
 
@@ -80,5 +80,5 @@
 
 #define ASSERT_SPINLOCK(expr, lock) \
-	ASSERT_VERBOSE(expr, (lock)->name)
+	assert_verbose(expr, (lock)->name)
 
 #define spinlock_lock(lock)    spinlock_lock_debug((lock))
@@ -98,5 +98,5 @@
 
 #define ASSERT_SPINLOCK(expr, lock) \
-	ASSERT(expr)
+	assert(expr)
 
 #define spinlock_lock(lock)    atomic_lock_arch(&(lock)->val)
@@ -175,5 +175,5 @@
 #define SPINLOCK_STATIC_INITIALIZE_NAME(name, desc_name)
 
-#define ASSERT_SPINLOCK(expr, lock)  ASSERT(expr)
+#define ASSERT_SPINLOCK(expr, lock)  assert(expr)
 
 #define spinlock_initialize(lock, name)
